(function ($, Drupal) {
  Drupal.behaviors.csvDatatables = {
    attach: function attach(context, settings) {

      $(context)
        .find("div.csv-table")
        .each(function () {
          var link = this.getElementsByTagName("a")[0];
          if (!link) {
            return;
          }
          var div = this;

          Papa.parse(link.href, {
            download: true,
            skipEmptyLines: true,
            complete: function (parsed) {
              var settings = JSON.parse(div.dataset.settings);
              if (typeof settings.responsive != "undefined") {
                if (settings.responsive === 'childRowImmediate') {
                  settings.responsive = {
                    details: {
                      display: $.fn.dataTable.Responsive.display.childRowImmediate,
                      type: ''
                    }
                  }
                }
                else {
                  settings.responsive = true;
                }
              }
              var table = document.createElement("table");
              div.classList.remove("csv-table");
              if (settings.download) {
                div.prepend(table);
              }
              else {
                div.innerHTML = "";
                div.prepend(table);
              }
              div.classList.remove('hidden');

              if (div.classList.contains("dataTable")) {
                var i;
                settings.columns = [];
                var headerData = parsed.data.shift();
                for (i = 0; i < headerData.length; i++) {
                  settings.columns.push({ title: headerData[i] });
                }

                settings.data = parsed.data;

                $(table).DataTable(settings);
              } else {
                var lines = parsed.data,
                  output = [],
                  i;
                // Add header.
                output.push(
                  "<thead><tr><th>" +
                    lines[0].join("</th><th>") +
                    "</th></tr></thead><tbody>"
                );

                div.classList.remove("csv-table");
                table.classList = div.classList;
                table.innerHTML = output;

                // Add other rows.
                for (i = 1; i < lines.length; i++)
                  output.push(
                    "<tr><td>" + lines[i].join("</td><td>") + "</td></tr>"
                  );

                output = output.join("") + "</tbody>";

                table.innerHTML = output;
              }
            },
          });
        });
    },
  };
})(jQuery, Drupal);
